# PhasicFlow: pFlow::pweBndryContactSearchKernels Namespace Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

pFlow::pweBndryContactSearchKernels Namespace Reference

## Functions

void | buildNextHead (const deviceScatteredFieldAccess< realx3 > &points, const cells &searchCells, deviceViewType3D< uint32 > &head, deviceViewType1D< uint32 > &next)

uint32

broadSearchPP (csPairContainerType &ppPairs, const deviceScatteredFieldAccess< realx3 > &points, const deviceScatteredFieldAccess< real > &diams, const deviceScatteredFieldAccess< realx3 > &mirrorPoints, const deviceScatteredFieldAccess< real > &mirrorDiams, const realx3 &transferVec, const deviceViewType3D< uint32 > &head, const deviceViewType1D< uint32 > &next, const cells &searchCells, real sizeRatio)

## Function Documentation

## buildNextHead()

void buildNextHead | ( | const deviceScatteredFieldAccess< realx3 > & | points,
|  | const cells & | searchCells,
|  | deviceViewType3D< uint32 > & | head,
|  | deviceViewType1D< uint32 > & | next
| ) |  |

Definition at line 10 of file ppwBndryContactSearchKernels.cpp.

References scatteredFieldAccess< T, MemorySpace >::empty(), LAMBDA_HD, n, cells::pointIndexInDomain(), and scatteredFieldAccess< T, MemorySpace >::size().

Referenced by ppwBndryContactSearch::buildList().

Here is the call graph for this function:
Here is the caller graph for this function:

## broadSearchPP()

pFlow::uint32 broadSearchPP | ( | csPairContainerType & | ppPairs,
|  | const deviceScatteredFieldAccess< realx3 > & | points,
|  | const deviceScatteredFieldAccess< real > & | diams,
|  | const deviceScatteredFieldAccess< realx3 > & | mirrorPoints,
|  | const deviceScatteredFieldAccess< real > & | mirrorDiams,
|  | const realx3 & | transferVec,
|  | const deviceViewType3D< uint32 > & | head,
|  | const deviceViewType1D< uint32 > & | next,
|  | const cells & | searchCells,
|  | real | sizeRatio
| ) |  |

Definition at line 39 of file ppwBndryContactSearchKernels.cpp.

References scatteredFieldAccess< T, MemorySpace >::empty(), cells::inCellRange(), unsortedPairs< executionSpace, idType >::insert(), LAMBDA_HD, cells::pointIndexInDomain(), scatteredFieldAccess< T, MemorySpace >::size(), and sphereSphereCheckB().

Referenced by ppwBndryContactSearch::broadSearchPP().

Here is the call graph for this function:
Here is the caller graph for this function: